# This file is a template, and might need editing before it works on your project.
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Go.gitlab-ci.yml

image: golang:latest

stages:
  # - test
  - unit-test
  - build
  - zipfile
  - deploy

test_api:
  stage: unit-test
  allow_failure: false
  # before_script:
  #   - cd api
  script:
    - go test ./...
  only:
    refs:
      - main
    # changes:
    #   - api/**/*
    #   - deployment/dev/api-deployment.yml

build:
  stage: build
  # image: golang:1.10-alpine3.7
  script:
    - go version
    - GOOS=linux GOARCH=amd64 go build -o main main.go
  only:
    - main
  artifacts:
    paths:
      - main

zipfile:
  stage: zipfile
  image: python:latest
  before_script:
    - apt-get update -q -y
    - apt-get install zip -y 
  script:
    - zip main.zip main
  artifacts:
    paths:
      - main.zip
    expire_in: 30 mins
  only:
    - main

deploy:
  stage: deploy
  image: 
    name: amazon/aws-cli
    entrypoint: [""]
  script:
    - aws --version
    - aws configure set region ap-south-1
    - aws lambda update-function-code --function-name test-deploy-go --zip-file fileb://main.zip
  dependencies:
    - build
  only:
    - main
